# Copyright (c) 2020 Red Hat, Inc.
# Copyright Contributors to the Open Cluster Management project
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.5.0
  creationTimestamp: null
  name: klusterletaddonconfigs.agent.open-cluster-management.io
spec:
  group: agent.open-cluster-management.io
  names:
    kind: KlusterletAddonConfig
    listKind: KlusterletAddonConfigList
    plural: klusterletaddonconfigs
    singular: klusterletaddonconfig
  scope: Namespaced
  versions:
  - name: v1
    schema:
      openAPIV3Schema:
        description: KlusterletAddonConfig is the Schema for the klusterletaddonconfigs API
        properties:
          apiVersion:
            description: 'APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources'
            type: string
          kind:
            description: 'Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds'
            type: string
          metadata:
            type: object
          spec:
            description: KlusterletAddonConfigSpec defines the desired state of KlusterletAddonConfig
            properties:
              applicationManager:
                description: ApplicationManagerConfig defines the configurations of ApplicationManager addon agent.
                properties:
                  enabled:
                    description: Enabled is the flag to enable/disable the addon. default is false.
                    type: boolean
                  proxyPolicy:
                    description: ProxyPolicy defines the policy to set proxy for each addon agent. default is Disabled. Disabled means that the addon agent pods do not configure the proxy env variables. OCPGlobalProxy means that the addon agent pods use the cluster-wide proxy config of OCP cluster provisioned by ACM. CustomProxy means that the addon agent pods use the ProxyConfig specified in KlusterletAddonConfig.
                    enum:
                    - Disabled
                    - OCPGlobalProxy
                    - CustomProxy
                    type: string
                type: object
              certPolicyController:
                description: CertPolicyControllerConfig defines the configurations of CertPolicyController addon agent.
                properties:
                  enabled:
                    description: Enabled is the flag to enable/disable the addon. default is false.
                    type: boolean
                  proxyPolicy:
                    description: ProxyPolicy defines the policy to set proxy for each addon agent. default is Disabled. Disabled means that the addon agent pods do not configure the proxy env variables. OCPGlobalProxy means that the addon agent pods use the cluster-wide proxy config of OCP cluster provisioned by ACM. CustomProxy means that the addon agent pods use the ProxyConfig specified in KlusterletAddonConfig.
                    enum:
                    - Disabled
                    - OCPGlobalProxy
                    - CustomProxy
                    type: string
                type: object
              clusterLabels:
                additionalProperties:
                  type: string
                description: DEPRECATED in release 2.4 and will be removed in the future since not used anymore.
                type: object
              clusterName:
                description: DEPRECATED in release 2.4 and will be removed in the future since not used anymore.
                minLength: 1
                type: string
              clusterNamespace:
                description: DEPRECATED in release 2.4 and will be removed in the future since not used anymore.
                minLength: 1
                type: string
              iamPolicyController:
                description: DEPRECATED in release 2.11 and will be removed in the future since not used anymore.
                properties:
                  enabled:
                    description: Enabled is the flag to enable/disable the addon. default is false.
                    type: boolean
                  proxyPolicy:
                    description: |-
                      ProxyPolicy defines the policy to set proxy for each addon agent. default is Disabled.
                      Disabled means that the addon agent pods do not configure the proxy env variables.
                      OCPGlobalProxy means that the addon agent pods use the cluster-wide proxy config of OCP cluster provisioned by ACM.
                      CustomProxy means that the addon agent pods use the ProxyConfig specified in KlusterletAddonConfig.
                    enum:
                    - Disabled
                    - OCPGlobalProxy
                    - CustomProxy
                    type: string
                type: object
              policyController:
                description: PolicyController defines the configurations of PolicyController addon agent.
                properties:
                  enabled:
                    description: Enabled is the flag to enable/disable the addon. default is false.
                    type: boolean
                  proxyPolicy:
                    description: ProxyPolicy defines the policy to set proxy for each addon agent. default is Disabled. Disabled means that the addon agent pods do not configure the proxy env variables. OCPGlobalProxy means that the addon agent pods use the cluster-wide proxy config of OCP cluster provisioned by ACM. CustomProxy means that the addon agent pods use the ProxyConfig specified in KlusterletAddonConfig.
                    enum:
                    - Disabled
                    - OCPGlobalProxy
                    - CustomProxy
                    type: string
                type: object
              proxyConfig:
                description: ProxyConfig defines the cluster-wide proxy configuration of the OCP managed cluster.
                properties:
                  httpProxy:
                    description: HTTPProxy is the URL of the proxy for HTTP requests.  Empty means unset and will not result in an env var.
                    type: string
                  httpsProxy:
                    description: HTTPSProxy is the URL of the proxy for HTTPS requests.  Empty means unset and will not result in an env var.
                    type: string
                  noProxy:
                    description: NoProxy is a comma-separated list of hostnames and/or CIDRs for which the proxy should not be used. Empty means unset and will not result in an env var. The API Server of Hub cluster should be added here. And If you scale up workers that are not included in the network defined by the networking.machineNetwork[].cidr field from the installation configuration, you must add them to this list to prevent connection issues.
                    type: string
                type: object
              searchCollector:
                description: SearchCollectorConfig defines the configurations of SearchCollector addon agent.
                properties:
                  enabled:
                    description: Enabled is the flag to enable/disable the addon. default is false.
                    type: boolean
                  proxyPolicy:
                    description: ProxyPolicy defines the policy to set proxy for each addon agent. default is Disabled. Disabled means that the addon agent pods do not configure the proxy env variables. OCPGlobalProxy means that the addon agent pods use the cluster-wide proxy config of OCP cluster provisioned by ACM. CustomProxy means that the addon agent pods use the ProxyConfig specified in KlusterletAddonConfig.
                    enum:
                    - Disabled
                    - OCPGlobalProxy
                    - CustomProxy
                    type: string
                type: object
              version:
                description: DEPRECATED in release 2.4 and will be removed in the future since not used anymore.
                type: string
            required:
            - applicationManager
            - certPolicyController
            - policyController
            - searchCollector
            type: object
          status:
            description: KlusterletAddonConfigStatus defines the observed state of KlusterletAddonConfig
            properties:
              conditions:
                description: Conditions contains condition information for the klusterletAddonConfig
                items:
                  description: "Condition contains details for one aspect of the current state of this API Resource. --- This struct is intended for direct use as an array at the field path .status.conditions.  For example, type FooStatus struct{     // Represents the observations of a foo's current state.     // Known .status.conditions.type are: \"Available\", \"Progressing\", and \"Degraded\"     // +patchMergeKey=type     // +patchStrategy=merge     // +listType=map     // +listMapKey=type     Conditions []metav1.Condition `json:\"conditions,omitempty\" patchStrategy:\"merge\" patchMergeKey:\"type\" protobuf:\"bytes,1,rep,name=conditions\"` \n     // other fields }"
                  properties:
                    lastTransitionTime:
                      description: lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed.  If that is not known, then using the time when the API field changed is acceptable.
                      format: date-time
                      type: string
                    message:
                      description: message is a human readable message indicating details about the transition. This may be an empty string.
                      maxLength: 32768
                      type: string
                    observedGeneration:
                      description: observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.
                      format: int64
                      minimum: 0
                      type: integer
                    reason:
                      description: reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.
                      maxLength: 1024
                      minLength: 1
                      pattern: ^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$
                      type: string
                    status:
                      description: status of the condition, one of True, False, Unknown.
                      enum:
                      - "True"
                      - "False"
                      - Unknown
                      type: string
                    type:
                      description: type of condition in CamelCase or in foo.example.com/CamelCase. --- Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important. The regex it matches is (dns1123SubdomainFmt/)?(qualifiedNameFmt)
                      maxLength: 316
                      pattern: ^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$
                      type: string
                  required:
                  - lastTransitionTime
                  - message
                  - reason
                  - status
                  - type
                  type: object
                type: array
              ocpGlobalProxy:
                description: OCPGlobalProxy is the cluster-wide proxy config of the OCP cluster provisioned by ACM
                properties:
                  httpProxy:
                    description: HTTPProxy is the URL of the proxy for HTTP requests.  Empty means unset and will not result in an env var.
                    type: string
                  httpsProxy:
                    description: HTTPSProxy is the URL of the proxy for HTTPS requests.  Empty means unset and will not result in an env var.
                    type: string
                  noProxy:
                    description: NoProxy is a comma-separated list of hostnames and/or CIDRs for which the proxy should not be used. Empty means unset and will not result in an env var. The API Server of Hub cluster should be added here. And If you scale up workers that are not included in the network defined by the networking.machineNetwork[].cidr field from the installation configuration, you must add them to this list to prevent connection issues.
                    type: string
                type: object
            type: object
        type: object
    served: true
    storage: true
    subresources:
      status: {}
status:
  acceptedNames:
    kind: ""
    plural: ""
  conditions: []
  storedVersions: []
